<?php
/**
 * @ H2N Link Directory 1.0.0 export.class.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 export.class.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

# Pfade ermitteln
$path = preg_replace("!(\\\)!i","/",dirname(__FILE__));
define('_LD_ABSOLUTE_PATH', str_replace("/administrator/components/com_linkdirectory","",$path));
define('_LD_BACKEND_PATH', $path );

// Joomla 1.0 - 1.5 switch
require_once( _LD_ABSOLUTE_PATH.'/configuration.php');
if (isset ($mosConfig_absolute_path)){
	define( '_VALID_MOS',1 );

} else {
	define( '_JEXEC', 1 );
}


// load joomla enviroment
if ( defined( '_JEXEC')) {
	define('JPATH_BASE', _LD_ABSOLUTE_PATH.'/administrator' );
	define('DS', DIRECTORY_SEPARATOR);
	require_once( JPATH_BASE .DS.'includes'.DS.'defines.php' );
	require_once( JPATH_BASE .DS.'includes'.DS.'framework.php' );
	require_once( JPATH_BASE .DS.'includes'.DS.'helper.php' );
	require_once( JPATH_BASE .DS.'includes'.DS.'toolbar.php' );
	$mainframe =& JFactory::getApplication('administrator');
	$user = & JFactory::getUser();
	$user_type = $user->get('usertype');
	$mainframe->initialise(array('language' => $mainframe->getUserState( "application.lang", 'lang' )));
	JPluginHelper::importPlugin('system');
} else {
	require_once( "../../../globals.php" );
	require_once( _LD_ABSOLUTE_PATH . "/includes/joomla.php" );
	global $database;
	$option='com_linkdirectory';
	$task='export';
	session_name( md5( $mosConfig_live_site ) );
	session_start();
	$session_id = mosGetParam( $_SESSION, 'session_id', '' );

	if ( ! $session_id ) {
		$user_type='';
	}
	else {
		$mainframe = new mosMainFrame( $database, $option, '../../..', true );
		$my = $mainframe->initSessionAdmin( $option, $task );
		$user_type = $my->usertype;
	}
}

// check user
if ( ($user_type != 'Administrator' ) && ($user_type != 'Super Administrator' )) die( 'Restricted access' );

// Send HTTP header ( dowloadable file )
header('Content-Type: application/x-msdownload');
header('Content-Disposition: attachment; filename="bookmark.html"');

require_once( _LD_BACKEND_PATH.'/linkdirectory.class.php' );
if (file_exists(_LD_BACKEND_PATH.'/language/'.$mosConfig_lang.'.php')){
	include(_LD_BACKEND_PATH.'/language/'.$mosConfig_lang.'.php');
}else{
	include(_LD_BACKEND_PATH.'/language/english.php');
}

// *****************************************
// *** Helper Function                   ***
// *****************************************
function convertData($string){
	if ( defined( '_JEXEC')) {
		return $string;
	}
	else {
		return utf8_encode($string);
	}
}

function writeBookmarkHeader(&$output){
	$output = '<!DOCTYPE NETSCAPE-Bookmark-file-1>'."\n";
	$output .= '<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">'."\n";
	$output .= '<TITLE>Bookmarks</TITLE>'."\n";
	$output .= '<H1>Bookmarks</H1>'."\n";
}

function writeBookmarks($bookmarks,$depth,&$output){
	foreach ($bookmarks as $bookmark) {
		$output .= str_repeat(' ', ($depth + 1) * 4);
		$output .= '<DT><A HREF="' . convertData($bookmark->url) . '" ADD_DATE="'. time() . '" LAST_VISIT="0" LAST_MODIFIED="0">';
		$output .= convertData($bookmark->title) . '</A>' . "\n";
		if ($bookmark->description) {
			$output .= str_repeat(' ', ($depth + 1) * 4);
			$output .= '<DD>' .convertData($bookmark->description)."\n";
		}
	}
}

function writeCategory($cat,$depth,&$output){

	$output  = str_repeat(' ', $depth * 4);
	$output .= '<DT><H3 FOLDED ADD_DATE="' . time() .  '">' . convertData($cat->title) . '</H3>' . "\n";
	$output .= str_repeat(' ', $depth * 4);
	if ($cat->description) {
		$output .= '<DD>' .convertData($cat->description)."\n";
	}
	$output .= str_repeat(' ', $depth * 4);
	$output .= '<DL><P>' . "\n";
}

function getAllLinksFromCategory($catid){
	global $database;
	$database->setQuery( "SELECT *"
	. "\n FROM #__ldlinks"
	. "\n WHERE catid = $catid"
	. "\n AND published=1"
	. "\n ORDER BY title"
	);
	$bookmarks = $database->loadObjectList();
	return $bookmarks;
}

function getChildCategory($catid){
	global $database;
	$database->setQuery( "SELECT *"
	. "\n FROM #__ldcats"
	. "\n WHERE parent_id = $catid"
	. "\n ORDER BY name"
	);
	$categories = $database->loadObjectList();
	return $categories;
}

// *****************************************
// *** Export Categories (with sub-cats) ***
// *****************************************

function export($cat, $depth) {
	global $database;

	writeCategory($cat,$depth,$output);
	$bookmarks= getAllLinksFromCategory($cat->id);
	writeBookmarks($bookmarks,$depth,$output);
	$categories=getChildCategory($cat->id);
	foreach ($categories as $cat) {
		$output .= export($cat, $depth + 1);
	}
	$output .= str_repeat(' ', $depth * 4) . '</DL><P>'  . "\n";
	return $output;
}

$catid 	= intval( mosGetParam( $_REQUEST, 'catid', 0 ) );

writeBookmarkHeader($output);
$output .= '<DL><P>'."\n";

$categories=getChildCategory($catid);
foreach ($categories as $cat) {
	$output .= export($cat, 1);
}

$bookmarks = getAllLinksFromCategory($catid);
writeBookmarks($bookmarks,0,$output);
$output .= '</DL><P>'."\n";
echo $output;

?>