<?php defined( '_VALID_MOS' ) or die( 'Restricted access' ); 

/**
 * Ausgabe eines Trennzeichen
 *
 * @param bool $firstItem true, wenn erstes Feld ausgegeben wurde, sonst false
 * @return Trennzeichen ' | ' oder ''
 */
function getTrenner(&$firstItem){
	if ($firstItem){
		$firstItem=false;
	} else {
		return ' | ';
	}
	return '';
}

/**
 * Ausgabe der URL des Links. Bei showfastlink gleich true 
 * und wenn die Detail-Seite nicht ausgegeben werden muss,
 * wird die URL des Link selbst zurückgegeben, ansonsten die URL der Detail-Seite.
 * 
 * Wird die URL selbts zurückgegeben, wird diese um [" target="_blank] ergänzt. 
 *
 * @param Object $tthis (->showfastlink und ->needDetailPage) 
 * @param String $link URL des Links selbst
 * @param String $urlToDetailPage URL zur Detail-Seite
 */
function echoTitleUrl ($tthis,&$link,&$urlToDetailPage){
	if ($tthis->showfastlink ) { 
    	echo getUrlToLink($link->url,$link->id,$tthis->Itemid); 
    	echo '" target="_blank'; 
	} else {
		if ( $tthis->needDetailPage){
			echo $urlToDetailPage;
		} else {
			echo getUrlToLink($link->url,$link->id,$tthis->Itemid); 
    		echo '" target="_blank';
		}	
	}
}
?>

<div  id="ldlinklist">
<table width="100%" border="0" class="linktable" cellpadding="0" cellspacing="0">
<?php if (($this->ldshowcatonlist) && (!$this->searchtext))  { ?>
  <!-- Cat Description -->
  <tr class="catdesc">
    <td class="catdesc" colspan="2"><?php echo stripslashes(getCatDescription($this->catid)); ?></td>
  </tr>
  <!-- Cat Description -->
  <?php } ?>
<?php
if (count($this->rows_of_links)) {
	$k = 0;
	for ($i=0, $n=count( $this->rows_of_links ); $i < $n; $i++) {
		$link = &$this->rows_of_links[$i];
		$url =        getItemUrl('detail', $link->id,$this->Itemid);
		$rateurl =    getItemUrl('rate',   $link->id,$this->Itemid);
		$commenturl = getItemUrl('comment',$link->id,$this->Itemid);
		$reporturl =  getItemUrl('report', $link->id,$this->Itemid);
		$description= getLinkDescription($link,$this->showlongdescription);
		$linkThumbImage = getThumbForLink($link->url,$link->title,$link->id,$link->thumburl,$link->image);
		?>
  <tr class="<?php echo $this->tabclass[$k]; ?>">
    <td class="linktitle"><a href="<?php echoTitleUrl($this,$link,$url)?>" class="title"><?php echo $link->title;?></a></td>
    <td class="linktitlecat"><?php if (isset($this->found)) { echo LDPathway( $link->catid ); } ?></td>
  </tr>
  <tr>
    <td class="linkdesc" colspan="2"><?php echo $linkThumbImage; echo $description;?></td>
  </tr>
  <?php if (($this->ratelink) || ($this->commentlink) || ($this->showhits) || ($this->ldshowlinkadd)) {?>
  <tr>
    <td class="linkoption" colspan="2">
    <?php $firstItem=true; ?>
    <?php if ($this->needDetailPage) { $firstItem=true; ?><a href="<?php echo $url;?>"><?php echo _LD_DETAILS; ?></a> |<?php } ?>
    <?php if ($this->ldshowlinkadd) { echo getTrenner($firstItem); echo $link->created; }?> 
    <?php if ($this->ratelink) { echo getTrenner($firstItem); echo showrating($link->rating, $link->votes);?> <a href="<?php echo $rateurl;?>"><?php echo $link->votes;?> <?php echo _LD_VOTES;?></a><?php } ?> 
    <?php if ($this->commentlink) { echo getTrenner($firstItem); ?><a href="<?php echo $commenturl;?>"><?php TotalComment($link->id);?> <?php echo _LD_COMMENTS;?></a><?php } ?>
    <?php if ($this->badlink) { echo getTrenner($firstItem); ?><a href="<?php echo $reporturl;?>"><?php echo _LD_REPORTBADLINK;?></a><?php } ?>
    <?php if ($this->showhits) { echo getTrenner($firstItem); echo $link->hits;?> <?php echo _LD_HITS; }?></td>
  </tr>
  <?php } 
		$k = 1 - $k;
	}
}
?>
</table>

<!-- Page navigation -->
<?php if ($this->pageNav) {  ?>
<table width="100%" class="navtable">
	<tr>
		<td class="navtable"><?php echo $this->pageNav->writePagesLinks($this->pageNavUrl); ?></td>
	</tr>
	<tr>
		<td class="navtable"><?php echo $this->pageNav->writePagesCounter(); ?></td>
	</tr>
</table>

<!-- Page navigation -->
<?php
	} 
?>
<!-- Link Thumb Back Link -->
<?php if (isLinkThumbEnable()) {  ?>
<table width="100%" class="navtable">
	<tr>
		<td class="navtable"><?php echo getBackLinkForLinkThumb(); ?></td>
	</tr>
</table>

<!-- Link Thumb Back Link -->
<?php
	} 
?>
</div>
